{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   gamemain.pp                                          }
{     ॳƥĤȤƤΥᥤ롼             }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: gamemain.pp,v 1.5 2002/08/10 03:05:14 rero2 Exp $ }
Unit   gamemain;

{$MODE Delphi}

interface

Uses  SDL, SDL_Types, SDL_Video, Grp_Screen, Grp_Sprite, Puz_Trial;


Type
  MainStep = (TitleInit, TitleIn, TitleMain, TitleStart, TitleFree,
              PuzzleInit, PuzzleMain, PuzzleFree);

  TGameMain = class(TObject)
    { ---  }
    private
    titletimer: Integer;
    tex: PSDL_Surface;
    bg, logo, push, release: TGameSprite;
    Screen: TGameScreen;
    Step: MainStep;
    Puzzle: TPuzzleTrial;
    { --- ʬ }
    public
    constructor Create(mainScreen: TGameScreen);
    destructor Destroy;
    Procedure poll(counter: Integer);
  end;

implementation
Uses  Debug, Input, Sound, Math;

var
  obj: Array [0..50] of TGameSprite;
  time: Integer;
  bgm, se: Integer;

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

constructor TGameMain.Create(mainScreen: TGameScreen);
begin
  screen := mainscreen;

  Step := TitleInit;
end;

destructor TGameMain.Destroy;
begin
  inherited;
end;

{ --------------------------------------------- }
{ --- ᥤ                          --- }
{ --------------------------------------------- }
procedure  TGameMain.poll(counter: Integer);
var
  i: Integer;
  sp: TGameSprite;
Begin
  { ----- ॹƥå }
  case Step of

    { -- ȥ }
    TitleInit:
      begin
        screen.LoadTexture(0, 'title01.pac');
        screen.LoadTexturePure(1, 'title02.pac');
	bg := screen.GetSprite(0);
	logo := screen.GetSprite(1);
	push := screen.GetSprite(2);
	release := screen.GetSprite(3);
        bg.DispSw := True;
        bg.x := 0;
        bg.y := 0;
        bg.w := 480;
        bg.h := 360;
        bg.tx := 0;
        bg.ty := 0;
        bg.texture := screen.GetTexture(0);
        bg.alpha := 255;
        logo.DispSw := False;
        logo.x := 0;
        logo.y := 0;
        logo.w := 400;
        logo.h := 112;
        logo.tx := 0;
        logo.ty := 0;
        logo.texture := screen.GetTexture(1);
        logo.alpha := 255;
        push.DispSw := False;
        push.x := 80;
        push.y := 240;
        push.w := 320;
        push.h := 30;
        push.tx := 0;
        push.ty := 114;
        push.texture := screen.GetTexture(1);
        push.alpha := 255;
        release.DispSw := False;
        release.x := 80;
        release.y := 320;
        release.w := 320;
        release.h := 16;
        release.tx := 0;
        release.ty := 144;
        release.texture := screen.GetTexture(1);
        release.alpha := 255;
        titletimer := 0;
        Step := TitleIn;
      end;

    { -- ȥե졼। }
    TitleIn:
      begin
        { -- SE }
        if titletimer = 15 then SoundSE(1);
        if titletimer > 20 then
        begin
          { Ϥ }
          logo.x := 38;
          logo.y := 120 - Round(sin(3.1415926 * 2.0 * ((Real(titletimer) - 20.0) / 60.0)) * 120.0);
          logo.DispSw := True;
        end
        else
        begin
          { 夫ߤäƤ }
          logo.x := 38;
          logo.y := 120 - ((20 - titletimer) * 20);
          logo.DispSw := True;
        end;
        { -- ؿʤॹƥå }
        titletimer := titletimer + 1;
        if titletimer = 38 then 
           SoundSE(6);
        if titletimer = 45 then 
        begin
          SoundMusic(2);
          Step := TitleMain;
        end;
        i := InputJoyKeyTriger(0);
        if (i and IN_Button1) <> 0 then
        begin
          SoundMusic(2);
          Step := TitleMain;
        end;
      end;

    { -- ȥܥԤ }
    TitleMain:
      begin
        logo.DispSw := True;
        logo.x := 38;
        logo.y := 60;
        release.DispSw := True;
        if ((titletimer div 4) mod 2) = 1 then
          push.DispSw := True
        else
          push.DispSw := False;
        titletimer := titletimer + 1;
        i := InputJoyKeyTriger(0);
        if (i and IN_Button1) <> 0 then
        begin
          SoundSE(2);
          titletimer := 0;
          Step := TitleStart;
        end;
      end;

    { -- Ȼȥ饯 }
    TitleStart:
      begin
        logo.DispSw := True;
        logo.x := 38;
        logo.y := 60;
        release.DispSw := True;
        if (titletimer mod 2) = 1 then
          push.DispSw := True
        else
          push.DispSw := False;
        titletimer := titletimer + 1;
        if titletimer = 20 then
        begin
          SoundMusicStop;
          Step := TitleFree;
        end;
      end;

    { -- ȥ夷ޤ }
    TitleFree:
      begin
        bg.DispSw := False;
        logo.DispSw := False;
        push.DispSw := False;
        release.DispSw := False;
        Step := PuzzleInit;
      end;


    { --  }
    PuzzleInit:
      begin
        Puzzle := TPuzzleTrial.Create(screen);
        Step := PuzzleMain;
      end;

    { -- ᥤ }
    PuzzleMain:
      begin
        Puzzle.GameMain;
        if Puzzle.GameStat = False then
          Step := PuzzleFree;
      end;

    { -- ཪλ夷ޤ }
    PuzzleFree:
      begin
        Puzzle.Free;
        for i := 0 to (SPRITEMAX -1) do
        begin
          sp := screen.GetSprite(i);
          sp.DispSW := False;
        end;
        Step := TitleInit;
      end;
  end;

end;

end.

