{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   grp_texture.pp                                       }
{     ̴饹                                     }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: grp_texture.pp,v 1.4 2002/08/08 04:31:15 rero2 Exp $ }
Unit Grp_Texture;

{$MODE Delphi}


interface

Uses classes, SDL, SDL_Types, SDL_Video;

Const
  { --- ƥ㡼 }
  TEXTUREMAX = 32;

Type
  TGameTexture = class(TObject)
    { ---  }
    private
    bitmap: array [0..TEXTUREMAX] of PSDL_Surface;
    { --- ʬ }
    public
    destructor Destroy;
    procedure Load(num: Integer; filename: String;
                            GameScreen: PSDL_Surface;
                            preconv: Boolean);
    function GetTexture(index: Integer): PSDL_Surface;
  end;



implementation
{ -------------------------------------------------------------- }
{ --- ƥ㡼饹                                     }
{ -------------------------------------------------------------- }

Uses  SDL_image, grp_screen;

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

destructor TGameTexture.Destroy;
var
  i: Integer;
begin
  inherited;
  { ----- ƥ㡼β }
  for i := 0 to TEXTUREMAX do
    if bitmap[i] <> nil then
    begin
      SDL_FreeSurface(bitmap[i]);
      bitmap[i] := nil;
    end;
end;


{ ---------------------------------------- }
{ --- ƥ㡼ɤ߹ߡϿ         }
{ ---------------------------------------- }
procedure TGameTexture.Load(num: Integer; filename: String;
                            GameScreen: PSDL_Surface;
                            preconv: Boolean);
var
  plane: PSDL_Surface;
begin
  { ----- ƥֹ椬ä齪λ }
  if num < 0 then Exit;
  if num > TEXTUREMAX then Exit;

  { ----- ˥ƥ㤬ä }
  if bitmap[num] <> nil then
  begin
    SDL_FreeSurface(bitmap[num]);
    bitmap[num] := nil;
  end;

  { ----- ƥ㡼ɤ߹ }
  plane := IMG_Load(PChar(filename));
  if plane = nil then
  begin
    bitmap[num] := nil;
    exit;
  end;
  if preconv = True then
  begin
    bitmap[num] := SDL_ConvertSurface(plane, GameScreen.format,
                                      SDL_SWSURFACE);
    if plane <> nil then SDL_FreeSurface(plane);
  end
  else
    bitmap[num] := plane;
end;


{ ---------------------------------------- }
{ --- ƥ㡼Ϥ                   }
{ ---------------------------------------- }
function TGameTexture.GetTexture(index: Integer): PSDL_Surface;
begin
  GetTexture := bitmap[index];
end;


end.
